#include <iostream>
#include <stdio.h>
#include <vector>
#include <assert.h>
#include <algorithm>
using namespace std;
typedef long long llong;

int n;
vector<int> active;
bool seen[1000111];
int firstp[1000111];
int lastp[1000111];
bool closed[1000111];

vector<pair<int, pair<int, int>>> moves;

int main()
{
    //freopen("painting.11.in", "r", stdin);

    int i;
    llong paint = 0;

    scanf("%d", &n);

    active.push_back(0);
    seen[0] = true;
    for (i=1;i<=n;i++)
    {
        int p;
        scanf("%d", &p);

        assert(!closed[p]);

        if (seen[p])
        {
            while(active.back() != p)
            {
                int col = active.back();
                moves.push_back({col, {firstp[col], lastp[col]}});
                active.pop_back();
                paint += lastp[col] - firstp[col] + 1;
                closed[col] = true;
            }

            lastp[p] = i;
        }
        else
        {
            firstp[p] = i;
            lastp[p] = i;
            active.push_back(p);
            seen[p] = true;
        }
    }
    while(active.back() != 0)
    {
        int col = active.back();
        moves.push_back({col, {firstp[col], lastp[col]}});
        active.pop_back();
        paint += lastp[col] - firstp[col] + 1;
    }

    reverse(moves.begin(), moves.end());

    printf("%d %lld\n", (int)moves.size(), paint);

    for (i=0;i<moves.size();i++)
    {
        printf("Move %d: %d %d %d\n", i + 1, moves[i].first, moves[i].second.first, moves[i].second.second);
    }

    return 0;
}
