#include <bits/stdc++.h>
using namespace std;

int a[100001];
int l[1000001];
int r[1000001];

int main() {
    int n; cin >> n;
    for (int i = 1; i <= n; i++) cin >> a[i];

    /// За всеки цвят x, в r[x] ще смятаме най-дясната дъста боядисана в този цвят
    for (int i = 1; i <= n; i++) r[a[i]] = i;

    /// За всеки цвят x, в l[x] ще смятаме най-лявата дъста боядисана в този цвят
    for (int i = n; i >= 1; i--) l[a[i]] = i;

    int moves = 0;
    /// броя ходове е равен на броя използвани цветове
    for (int i = 1; i <= 1000000; i++) {
        /// за всеки използван цвят увеличаваме броя ходове
        if (l[i] != 0) moves++;
    }

    int len = 0;
    /// боядисаната дължина за всеки цвят зависи от най-лявата и най-дясната дъска,
    /// които са боядисани в този цвят
    /// общата използвана боя е сумата от боите използвани за всички цветове
    for (int i = 1; i <= 1000000; i++) {
        if (l[i] != 0) len+=r[i]-l[i]+1;
    }
    cout << moves << " " << len << endl;

    /// За всеки използван цвят трябва да има по един ход.
    /// Този ход започва от най-лявата дъска с този цвят и свършва в най-дясната такава
    /// Първата дъска винаги може да участва в първия ход.
    /// Нека първата дъска участва в боядисване в интервала от 1 до x.
    /// Можем да кажем, че първия ход е от 1 до x и
    /// това разделя оградата на два независими интервала от 2 до x-1 и от x+1 до n.
    /// Всяко боядисване е само в един от тези два интервала и то може да е било след боядисването 1 x
    /// Сега вече цвета на първата клетка е получен.
    /// Продължаваме аналогично с втората клетка.
    int br = 0;
    for (int i = 1; i <= n; i++) {
        if (a[i] != 0 && l[a[i]] == i) {
            br++;
            cout << "Move " << br << ": " << a[i] << " " << l[a[i]] << " " << r[a[i]] << endl;
        }
    }

    return 0;
}
/**
10
0 5 5 3 7 3 3 2 8 2
*/
